unit slide;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, shellapi, Jpeg, ComCtrls, Grids,
  IniFiles, Buttons;

type
  TSlideBox = class(TForm)
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    Panel1: TPanel;
    File1: TMenuItem;
    Show1: TMenuItem;
    Run: TMenuItem;
    Open: TMenuItem;
    Set1: TMenuItem;
    OpenFolder: TMenuItem;
    N2: TMenuItem;
    Image1: TImage;
    StatusBar1: TStatusBar;
    procedure OpenClick(Sender: TObject);
    procedure RunClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Image1Click(Sender: TObject);
    procedure OpenFolderClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtnRClick(Sender: TObject);
    procedure BitBtnLClick(Sender: TObject);
    procedure Screen1Click(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
  private
    { Private declarations }
    procedure DropPicture(var Message: TWMDROPFILES); message WM_DROPFILES;
  public
    { Public declarations }
    Filelist,SizeList :TStringList; {  StringList
         }
    JpgIm: TJpegImage; {  Jpeg}
    BmpIm: TBitMap; {  BitMap}
  end;

    procedure Loadfile;
var
  SlideBox: TSlideBox;
  srf: TSearchRec;
  ni,n,nfiles: integer;
  IniFile:TIniFile;
  mayClose: boolean=False; {  }
  stpath:string = 'C:\';
  fmusic:string='';
  fname:string;
  buffer : array[0..255] of char;
  FlagMusic:byte=0;
  FlagE:byte=0;
  MinFlag:boolean=True;

implementation

{$R *.dfm}

function NumFiles:boolean;
begin   {      }
  result:=True;
  nfiles:=0;
  if FindFirst('*.*',faAnyFile,srf)=0 then
  begin {  ,   ,  jpg  bmp}
    repeat
      if (ExtractFileExt(AnsiLowerCase(srf.Name))='.bmp') or (ExtractFileExt(AnsiLowerCase(srf.Name))='.jpg')
      or (ExtractFileExt(AnsiLowerCase(srf.Name))='.jpeg') then
      nfiles:=nfiles+1;
    until (FindNext(srf)<>0);
  end;
  FindClose(srf);
  if nfiles=0 then result:=False else
end;

procedure PictureList; {    }
var
  st: string;
  nfiles: integer;
begin
  if not NumFiles then exit;  {  ,  }
  if SlideBox.Timer1.Enabled=True then {   - }
  begin
    SlideBox.Run.Caption:=''; {      ""}
    SlideBox.Timer1.Enabled:=False;  { }
  end;
  ni:=0; { }
  with SlideBox do
  begin
    OpenDialog1.InitialDir:=stPath; {   }
    ChDir(stpath); {  }
    IniFile:=TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini')); { ini}
    IniFile.WriteString('Main','Path',stpath);
    IniFile.Destroy;
//    StaticText1.Caption:=stPath;   {   }
    if fname<>'' then
//    StaticTextName.Caption:=ExtractFileName(fname);
//    StaticTextSize.Caption:=''; { }
//    StaticTextN.Caption:=''; { }
//    StaticTextNFile.Caption:=''; { }
    Application.ProcessMessages; {,  }
    FileList.Clear;  { }
    Filelist.Sorted:=True; {     }
    JpgIm := TJpegImage.Create; { Jpeg}
    BmpIm := TBitMap.Create; { BitMap}
   if FindFirst('*.*',faAnyFile,srf)=0 then
   begin {  ,   ,  jpg  bmp}
    repeat
      if (ExtractFileExt(AnsiLowerCase(srf.Name))='.bmp') then
      begin
           try
             BmpIm.LoadFromFile(srf.Name); {    }
           except {     -    }
              continue; { }
           end;
           Filelist.Add(srf.Name+'*'+IntToStr(BmpIm.Width)+'x'+IntToStr(BmpIm.Height));  {   
               }
           if fname<>'' then
           if srf.Name = ExtractFileName(fname) then
           begin
//             StaticTextSize.Caption:=IntToStr(BmpIm.Width)+'x'+IntToStr(BmpIm.Height);
             Application.ProcessMessages;  {   }
           end;
      end;
      if (ExtractFileExt(AnsiLowerCase(srf.Name))='.jpg') or (ExtractFileExt(AnsiLowerCase(srf.Name))='.jpeg') then
      begin
           try
              JpgIm.LoadFromFile(srf.Name); {    }
           except {     -    Jpeg}
              continue; { }
           end;
           Filelist.Add(srf.Name+'*'+IntToStr(JpgIm.Width)+'x'+IntToStr(JpgIm.Height));  {   
               }
           if fname<>'' then
           if srf.Name = ExtractFileName(fname) then
           begin
//             StaticTextSize.Caption:=IntToStr(JpgIm.Width)+'x'+IntToStr(JpgIm.Height);
             Application.ProcessMessages; {   }
           end;
      end;
    until (FindNext(srf)<>0);
   end;
   BmpIm.Destroy; { BitMap}
   JpgIm.Destroy; { Jpeg}

   Filelist.Sorted:=False; {   }

   for nfiles := 0 to Filelist.Count-1 do {   }
   begin
     st:=Filelist[nfiles];
     Filelist[nfiles]:=copy(st,1,pos('*',st)-1);
     SizeList.Add(copy(st,pos('*',st)+1,length(st)));
   end;  {  Filelist ,   SizeList - }

   n:=0;
   for nfiles := 0 to Filelist.Count-1 do {    -    }
   if Filelist[nfiles] = ExtractFileName(fname) then
   begin
//    StaticTextN.Caption:=IntToStr(nfiles+1);
     n:=nfiles; break end;
     {  ,   n -    ,  n=0}
     nfiles:=Filelist.Count;
//   StaticTextNFile.Caption:=IntToStr(nfiles); {  }
  end;
end {PictureList};

procedure TSlideBox.DropPicture(var Message: TWMDROPFILES);
begin { ,   }
  DragQueryFile(Message.Drop,0,@buffer,sizeof(buffer));
  try
    Image1.Picture.LoadFromFile(buffer); { }
  except
     exit;
  end;
  fname:=buffer;
  stpath:=ExtractFileDir(fname); {    "\"}
  PictureList; {    }
end;

procedure Loadfile; {     JPEG}
begin
  with SlideBox do
  begin
//    StaticTextN.Caption:=IntToStr(n+1);
//    StaticTextName.Caption:=Filelist[n]; {  }
    fname:=stpath+'\'+Filelist[n];
    Image1.Picture.LoadFromFile(fname); {}
//    StaticTextSize.Caption:=Sizelist[n]; {  }
  end;
end;

procedure TSlideBox.Timer1Timer(Sender: TObject);
begin
  if Filelist.Count=0 then exit; {   - }
  n:=n+1;
  if n>Filelist.Count-1 then n:=0; {}
    {    :}
  Loadfile;
end;

procedure TSlideBox.BitBtnRClick(Sender: TObject);
begin { -   }
  if Filelist.Count=0 then exit; {   - }
  n:=n+1;
  if n>Filelist.Count-1 then n:=0; {}
    {    :}
  Loadfile;
end;


procedure TSlideBox.BitBtnLClick(Sender: TObject);
begin { -   }
  if Filelist.Count=0 then exit; {   - }
  if n=0 then n:=Filelist.Count-1 else n:=n-1;{}
      {    :}
  Loadfile;
end;


procedure TSlideBox.OpenClick(Sender: TObject); { }
begin
  OpenDialog1.InitialDir:=stpath;
  If OpenDialog1.Execute then {     }
  Image1.Picture.LoadFromFile(OpenDialog1.FileName)   {   Image1}
  else exit; {,    ,    }
   fname:=OpenDialog1.FileName; {   }
   stpath:=ExtractFileDir(fname); {    "\"}
  PictureList; {    }
end;

procedure TSlideBox.RunClick(Sender: TObject); {    }
begin
  if Filelist.Count=0 then exit; {   - }
  if Timer1.Enabled=False then {   }
  begin
    Run.Caption:=''; {     ""}
    Timer1.Enabled:=True; { }
  end else {,    }
  begin
    Run.Caption:=''; {      ""}
    Timer1.Enabled:=False;  { }
  end;
end;

procedure TSlideBox.FormDeactivate(Sender: TObject);
begin
//  Panel2.Visible:=False; { }
end;

procedure TSlideBox.FormCreate(Sender: TObject);
var x:integer;
begin
   IniFile:=TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini')); {   - ,  }
   with IniFile do
   begin
     if SectionExists('Main') then {       }
     begin
        Timer1.Interval:=ReadInteger('Main','Timer interval',3000); {  3c}
        x:=ReadInteger('Main','Color',0); {   0}
        if x>15 then { -  }
        begin
          x:=0; { }
          WriteInteger('Main','Color',0);
        end;
        stpath:=ReadString('Main','Path','C:\'); {   C}
        try
          ChDir(stpath); {  }
        except
          stpath:='C:\';
          ChDir(stpath); {   -  C}
        end;
     end else  {    }
     begin
        WriteInteger('Main','Timer interval',Timer1.Interval);
        WriteInteger('Main','Color',0); {  0   ColorBox -  }
        WriteString('Main','Path',stpath);
        WriteString('Main','Musicfile',''); {  }
        WriteBool('Main','Music',False);
     end;
     if SectionExists('Sets') then {       }
     begin
     end;
     Destroy;
   end;  {IniFile}
   {=======  ====================}
   Filelist := TStringList.Create; {   }
   Filelist.Sorted := False; {   }
   SizeList := TStringList.Create; {   }
   Sizelist.Sorted := False; {   }
   DragAcceptFiles(SlideBox.Handle,True); {,     }
end; {Create}

procedure TSlideBox.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{  Enter   }
  if key=vk_Return then
  FindNextControl(Sender as TWinControl, true, true, false).SetFocus;
end;

procedure TSlideBox.Image1Click(Sender: TObject);
begin { }
    if Filelist.Count=0 then exit; {   - }
    n := n+1;
    if n>Filelist.Count-1 then n := 0; {}
     {    :}
    Loadfile;
end;

procedure TSlideBox.OpenFolderClick(Sender: TObject);
begin   { }
   fname := ''; { }
   PictureList; {    }
    if Filelist.Count=0 then exit;
//    StaticText1.Caption := stPath;
    {    :}
    n := 0;
    Loadfile;
end;

procedure TSlideBox.FormDestroy(Sender: TObject);
begin
  FileList.Destroy; { }
  Sizelist.Destroy;
  { :}
  IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini')); { ini}
  IniFile.WriteString('Main','Musicfile',fmusic); {  }
  IniFile.Destroy;
end;

procedure TSlideBox.FormActivate(Sender: TObject);
begin
  if paramcount<>0 then  {   }
  begin
    try
      Image1.Picture.LoadFromFile(paramstr(1));
      {  }
    except
      exit;
    end;
    fname := paramstr(1);
    stpath := ExtractFileDir(fname); {    "\"}
    PictureList; {    }
  end;
end;

procedure TSlideBox.Screen1Click(Sender: TObject);
begin   {  }
   if SlideBox.Filelist.Count=0 then exit; {     - }
   if BorderStyle=bsSizeable then
   begin
      BorderStyle  :=  bsNone;
      FormStyle    :=  fsStayOnTop;
      Left         :=  0;
      Top          :=  0;
      Height :=  Screen.Height;
      Width  :=  Screen.Width;
   end else
   begin
      BorderStyle  :=  bsSizeable;
      FormStyle    :=  fsNormal;
      Height :=  620;
      Width  :=  850;
      Position := poDesktopCenter;
   end;
end;

procedure TSlideBox.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
{  }
begin
   if SlideBox.Filelist.Count=0 then exit; {    }
   if (Msg.CharCode=vk_Right) or (Msg.CharCode=vk_Space) then {  " "  }
   begin
     Handled := True; {  -    .}
     if Filelist.Count=0 then exit; {   - }
     n := n+1;
     if n>Filelist.Count-1 then n := 0; {}
    {    :}
     Loadfile;
   end;
   if Msg.CharCode=vk_Left then {  " "}
   begin
     Handled := True; {  -    .}
     if Filelist.Count=0 then exit; {   - }
     if n=0 then n := Filelist.Count-1 else n := n-1;{}
      {    :}
     Loadfile;
   end;
   if Msg.CharCode=vk_Escape then {  Escape}
   begin   {  }
     Handled := True; {  -    .}
     if BorderStyle=bsSizeable then
     begin
        BorderStyle := bsNone;
        FormStyle   := fsStayOnTop;
        Left        := 0;
        Top         := 0;
        Height :=  Screen.Height;
        Width  :=  Screen.Width;
     end else
     begin
        BorderStyle := bsSizeable;
        FormStyle   := fsNormal;
        Height := 620;
        Width  := 850;
        Position := poDesktopCenter;
     end;
   end;
end;

end.

